/* Copyright (C) 1998-1999 Kimmo.palin@helsinki.fi
   License: see COPYING
*/
#ifndef _CPU_H
#define _CPU_H
#include"ttk91vm.h"

#include<gtk/gtk.h>


/* Reksiterit */
#define REGISTERS 8

#define SPREG 6
#define FPREG 7

/*
extern bit32 cpu_regs[REGISTERS];
*/

#ifdef HUGE_CORE
#define DEF_CORE 16384  /* Kuka tarvii yli 64k muistia??*/
#else
#define DEF_CORE 1024   /* Bill Gateskin saa basicin 4 kiloon */
#endif

#define WORDSIZE 4

extern int ttk_errno;

#define REGFAULT 1

typedef union {
   bit32 bin;   /* Binriesitys*/
   opdata flds; /* Kenttesitys*/
 } memunit;

typedef struct {
  unsigned int CPUid;
  /* Yleiset rekisterit */
  bit32 regs[REGISTERS];
  /* CU */
  bit32 pc,sr,tr;
  opdata ir;
  /* MMU */
  bit32 limit,base,mar;
  memunit mbr;
} cpudev;


void exec_instr(cpudev *cpu);

/* Filosofinen kysymys: Pitisik set/getMem kytt osoittimia vai arvoja?*/
cpudev *run_cpu(cpudev *ring);
cpudev *init_cpu();

char *asmOp(char *buffer,bit8 code);


/* Defined in gladesig.c */
void crt_message(int value);
void kbd_input();
/* in cpu.c*/
void kbd_input_done(int value);

/* "Oikea" ajo */
gint process_timeout(gpointer data);

#endif





