/* Copyright (C) 1998-1999 Kimmo.palin@helsinki.fi
   License: see COPYING
*/

#include"cpu_access.h"
#include"cpu.h"


/* Bitwise or with SR */
bit32 or_sr(cpudev *cpu,bit32 value)
{
  set_sr(cpu,get_sr(cpu)|value);

  return get_sr(cpu);
}
bit32 xor_sr(cpudev *cpu,bit32 value)
{
  set_sr(cpu,get_sr(cpu)^value);

  return get_sr(cpu);
}

/* Sets value to pc-reg of specified CPU*/
void set_pc(cpudev *cpu,bit32 value)
{
  gchar val[64];

  sprintf(val,"%d",value);
  gtk_clist_set_text(GtkCPURegList,0,1,val);
  gtk_clist_select_row(GtkCPURegList,0,0);

  cpu->pc=value;
}
void set_sr(cpudev *cpu,bit32 value)
{
  gchar val[64];

  sprintf(val,"%d",value);
  gtk_clist_set_text(GtkCPURegList,2,1,val);
  gtk_clist_select_row(GtkCPURegList,2,0);
  cpu->sr=value;
}
void set_ir(cpudev *cpu,opdata value)
{
  gchar val[64];

  sprintf(val,"%d",value);
  gtk_clist_set_text(GtkCPURegList,3,1,val);
  gtk_clist_select_row(GtkCPURegList,3,0);

  cpu->ir=value;
}
void set_tr(cpudev *cpu,bit32 value)
{
  gchar val[64];

  sprintf(val,"%d",value);
  gtk_clist_set_text(GtkCPURegList,1,1,val);
  gtk_clist_select_row(GtkCPURegList,1,0);

  cpu->tr=value;
}

void set_base(cpudev *cpu,bit32 value)
{
  if((get_sr(cpu)&STAT_P)==0)
    fprintf(stderr,"Privlige fault!\n");
  cpu->base=value;
}
void set_limit(cpudev *cpu,bit32 value)
{
  if((get_sr(cpu)&STAT_P)==0)
    fprintf(stderr,"Privlige fault!\n");
  cpu->limit=value;
}

void set_mar(cpudev *cpu,bit32 value)
{
  cpu->mar=value;
  cpu->mbr=getMem(cpu,cpu->mar);
}
void set_mbr(cpudev *cpu,memunit value)
{
  cpu->mbr=value;
}

void set_reg(cpudev *cpu,bit32 value,unsigned int index)
{
  gchar val[64];

  sprintf(val,"%d",value);
  gtk_clist_set_text(GtkRegList,index,1,val);
  gtk_clist_select_row(GtkRegList,index,0);

  cpu->regs[index]=value;
}




bit32 get_pc(cpudev *cpu) 
{
  gtk_clist_select_row(GtkCPURegList,0,0);
  return cpu->pc;
}
bit32 get_sr(cpudev *cpu) 
{
  gtk_clist_select_row(GtkCPURegList,2,0);
  return cpu->sr;
}
bit32 get_tr(cpudev *cpu) 
{
  gtk_clist_select_row(GtkCPURegList,1,0);
  return cpu->tr;
}
opdata get_ir(cpudev *cpu)
{
  gtk_clist_select_row(GtkCPURegList,3,0);

  return cpu->ir;
}
bit32 get_limit(cpudev *cpu) 
{
  return cpu->limit;
}
bit32 get_base(cpudev *cpu) 
{
  return cpu->base;
}
bit32 get_reg(cpudev *cpu,unsigned int index) 
{
  gtk_clist_select_row(GtkRegList,index,0);

  return cpu->regs[index];
}
memunit get_mbr(cpudev *cpu) 
{
  return cpu->mbr;
}

bit32 get_mar(cpudev *cpu) 
{
  return cpu->mar;
}



